Index: drivers/sound/cmpci.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/sound/cmpci.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/sound/cmpci.c	22 Jul 2004 19:50:19 -0000	1.1
+++ drivers/sound/cmpci.c	4 Aug 2004 01:29:45 -0000	1.2
@@ -3156,42 +3595,74 @@
 MODULE_DESCRIPTION("CM8x38 Audio Driver");
 MODULE_LICENSE("GPL");
 
-
-static void __exit cleanup_cmpci(void)
+static void __devinit cm_remove(struct pci_dev *dev)
 {
-	struct cm_state *s;
-
-	while ((s = devs)) {
-		devs = devs->next;
-		outb(0, s->iobase + CODEC_CMI_INT_HLDCLR + 2);  /* disable ints */
-		synchronize_irq();
-		outb(0, s->iobase + CODEC_CMI_FUNCTRL0 + 2); /* disable channels */
-		free_irq(s->irq, s);
+	struct cm_state *s = pci_get_drvdata(dev);
 
-		/* reset mixer */
-		wrmixer(s, DSP_MIX_DATARESETIDX, 0);
-
-		release_region(s->iobase, CM_EXTENT_CODEC);
+	if (!s)
+		return;
+	list_del(&s->devs);
+	outb(0, s->iobase + CODEC_CMI_INT_HLDCLR + 2);  /* disable ints */
+	synchronize_irq();
+	outb(0, s->iobase + CODEC_CMI_FUNCTRL0 + 2); /* disable channels */
+	free_irq(s->irq, s);
+
+	/* reset mixer */
+	wrmixer(s, DSP_MIX_DATARESETIDX, 0);
+
+	if (s->gameport.io) {
+		gameport_unregister_port(&s->gameport);
+		release_region(s->gameport.io, CM_EXTENT_GAME);
+	}
+	release_region(s->iobase, CM_EXTENT_CODEC);
 #ifdef CONFIG_SOUND_CMPCI_MIDI
-		if (s->iomidi) release_region(s->iomidi, CM_EXTENT_MIDI);
+	if (s->iomidi) release_region(s->iomidi, CM_EXTENT_MIDI);
 #endif
 #ifdef CONFIG_SOUND_CMPCI_FM
-		if (s->iosynth) release_region(s->iosynth, CM_EXTENT_SYNTH);
+	if (s->iosynth) release_region(s->iosynth, CM_EXTENT_SYNTH);
 #endif
-		unregister_sound_dsp(s->dev_audio);
-		unregister_sound_mixer(s->dev_mixer);
+	unregister_sound_dsp(s->dev_audio);
+	unregister_sound_mixer(s->dev_mixer);
 #ifdef CONFIG_SOUND_CMPCI_MIDI
-		unregister_sound_midi(s->dev_midi);
+	unregister_sound_midi(s->dev_midi);
 #endif
 #ifdef CONFIG_SOUND_CMPCI_FM
-		unregister_sound_special(s->dev_dmfm);
+	unregister_sound_special(s->dev_dmfm);
 #endif
-		kfree(s);
-	}
-	if (wavetable_mem)
-		free_pages(wavetable_mem, 20-PAGE_SHIFT);
+	kfree(s);
+	pci_set_drvdata(dev, NULL);
+}
+
+static struct pci_device_id id_table[] __devinitdata = {
+	{ PCI_VENDOR_ID_CMEDIA, PCI_DEVICE_ID_CMEDIA_CM8738, PCI_ANY_ID, PCI_ANY_ID, 0, 0 },
+ 	{ PCI_VENDOR_ID_CMEDIA, PCI_DEVICE_ID_CMEDIA_CM8338A, PCI_ANY_ID, PCI_ANY_ID, 0, 0 },
+	{ PCI_VENDOR_ID_CMEDIA, PCI_DEVICE_ID_CMEDIA_CM8338B, PCI_ANY_ID, PCI_ANY_ID, 0, 0 },
+	{ 0, }
+};
+
+MODULE_DEVICE_TABLE(pci, id_table);
+
+static struct pci_driver cm_driver = {
+       name: "cmpci",
+       id_table: id_table,
+       probe: cm_probe,
+       remove: cm_remove
+};
+ 
+static int __init init_cmpci(void)
+{
+	if (!pci_present())   /* No PCI bus in this machine! */
+		return -ENODEV;
+	printk(KERN_INFO "cmpci: version $Revision: 1.2 $ time " __TIME__ " " __DATE__ "\n");
+	return pci_module_init(&cm_driver);
+}
+
+static void __exit cleanup_cmpci(void)
+{
 	printk(KERN_INFO "cmpci: unloading\n");
+	pci_unregister_driver(&cm_driver);
 }
 
 module_init(init_cmpci);
 module_exit(cleanup_cmpci);
+
Index: drivers/sound/cs46xx.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/sound/cs46xx.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/sound/cs46xx.c	22 Jul 2004 19:50:20 -0000	1.1
+++ drivers/sound/cs46xx.c	4 Aug 2004 01:29:45 -0000	1.2
@@ -312,6 +312,9 @@
 	/* The cs461x has a certain amount of cross channel interaction
 	   so we use a single per card lock */
 	spinlock_t lock;
+	
+	/* Keep AC97 sane */
+	spinlock_t ac97_lock;
 
 	/* mixer use count */
 	atomic_t mixer_use_cnt;
@@ -947,8 +950,8 @@
 
 struct InitStruct
 {
-    u32 long off;
-    u32 long val;
+    u32 off;
+    u32 val;
 } InitArray[] = { {0x00000040, 0x3fc0000f},
                   {0x0000004c, 0x04800000},
 
@@ -3823,11 +3826,12 @@
 /* Write AC97 codec registers */
 
 
-static u16 cs_ac97_get(struct ac97_codec *dev, u8 reg)
+static u16 _cs_ac97_get(struct ac97_codec *dev, u8 reg)
 {
 	struct cs_card *card = dev->private_data;
 	int count,loopcnt;
 	unsigned int tmp;
+	u16 ret;
 	
 	/*
 	 *  1. Write ACCAD = Command Address Register = 46Ch for AC97 register address
@@ -3838,7 +3842,6 @@
 	 *  6. Read ACSTS = Status Register = 464h, check VSTS bit
 	 */
 
-
 	cs461x_peekBA0(card, BA0_ACSDA);
 
 	/*
@@ -3929,7 +3932,19 @@
 		"cs46xx: cs_ac97_get() reg = 0x%x, val = 0x%x, BA0_ACCAD = 0x%x\n", 
 			reg, cs461x_peekBA0(card, BA0_ACSDA),
 			cs461x_peekBA0(card, BA0_ACCAD)));
-	return(cs461x_peekBA0(card, BA0_ACSDA));
+	ret = cs461x_peekBA0(card, BA0_ACSDA);
+	return ret;
+}
+
+static u16 cs_ac97_get(struct ac97_codec *dev, u8 reg)
+{
+	u16 ret;
+	struct cs_card *card = dev->private_data;
+	
+	spin_lock(&card->ac97_lock);
+	ret = _cs_ac97_get(dev, reg);
+	spin_unlock(&card->ac97_lock);
+	return ret;
 }
 
 static void cs_ac97_set(struct ac97_codec *dev, u8 reg, u16 val)
@@ -3938,11 +3953,14 @@
 	int count;
 	int val2 = 0;
 	
+	spin_lock(&card->ac97_lock);
+	
 	if(reg == AC97_CD_VOL)
 	{
-		val2 = cs_ac97_get(dev, AC97_CD_VOL);
+		val2 = _cs_ac97_get(dev, AC97_CD_VOL);
 	}
 	
+	
 	/*
 	 *  1. Write ACCAD = Command Address Register = 46Ch for AC97 register address
 	 *  2. Write ACCDA = Command Data Register = 470h    for data to write to AC97
@@ -3990,6 +4008,8 @@
 			"cs46xx: AC'97 write problem, reg = 0x%x, val = 0x%x\n", reg, val));
 	}
 
+	spin_unlock(&card->ac97_lock);
+
 	/*
 	 *	Adjust power if the mixer is selected/deselected according
 	 *	to the CD.
@@ -4235,9 +4255,8 @@
 		"cs46xx: cs_ac97_init()+\n") );
 
 	for (num_ac97 = 0; num_ac97 < NR_AC97; num_ac97++) {
-		if ((codec = kmalloc(sizeof(struct ac97_codec), GFP_KERNEL)) == NULL)
+		if ((codec = ac97_alloc_codec()) == NULL)
 			return -ENOMEM;
-		memset(codec, 0, sizeof(struct ac97_codec));
 
 		/* initialize some basic codec information, other fields will be filled
 		   in ac97_probe_codec */
@@ -4260,10 +4279,10 @@
 
 		eid = cs_ac97_get(codec, AC97_EXTENDED_ID);
 		
-		if(eid==0xFFFFFF)
+		if(eid==0xFFFF)
 		{
 			printk(KERN_WARNING "cs46xx: codec %d not present\n",num_ac97);
-			kfree(codec);
+			ac97_release_codec(codec);
 			break;
 		}
 		
@@ -4271,7 +4290,7 @@
 			
 		if ((codec->dev_mixer = register_sound_mixer(&cs_mixer_fops, -1)) < 0) {
 			printk(KERN_ERR "cs46xx: couldn't register mixer!\n");
-			kfree(codec);
+			ac97_release_codec(codec);
 			break;
 		}
 		card->ac97_codec[num_ac97] = codec;
@@ -5311,6 +5330,7 @@
 	card->irq = pci_dev->irq;
 	card->magic = CS_CARD_MAGIC;
 	spin_lock_init(&card->lock);
+	spin_lock_init(&card->ac97_lock);
 
 	pci_set_master(pci_dev);
 
@@ -5438,7 +5458,7 @@
 			for (j = 0; j < NR_AC97; j++)
 				if (card->ac97_codec[j] != NULL) {
 					unregister_sound_mixer(card->ac97_codec[j]->dev_mixer);
-					kfree (card->ac97_codec[j]);
+					ac97_release_codec(card->ac97_codec[j]);
 				}
 			mdelay(10 * cs_laptop_wait);
 			continue;
@@ -5595,7 +5615,7 @@
 	for (i = 0; i < NR_AC97; i++)
 		if (card->ac97_codec[i] != NULL) {
 			unregister_sound_mixer(card->ac97_codec[i]->dev_mixer);
-			kfree (card->ac97_codec[i]);
+			ac97_release_codec(card->ac97_codec[i]);
 		}
 	unregister_sound_dsp(card->dev_audio);
         if(card->dev_midi)
Index: drivers/sound/ep93xx-audio.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/sound/ep93xx-audio.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/sound/ep93xx-audio.h	22 Jul 2004 19:50:19 -0000	1.1
+++ drivers/sound/ep93xx-audio.h	29 Sep 2006 22:29:35 -0000	1.2
@@ -1,128 +1,178 @@
-/*
- * ep93xx-audio.h
- *
- * Common audio handling for the Cirrus Logic EP93xx
- *
- * Copyright (c) 2003 Cirrus Logic Corp.
- * Copyright (c) 2000 Nicolas Pitre <nico@cam.org>
- *
- * Taken from sa1100-audio.h
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License.
- */
-
-/*
- * If this is #defined we will up the number of buffers we allocate so 
- * that if an application requests 2 16K buffers for playing 16 bit audio,
- * we will allocate 4 16K buffers so we have room to expand the 16 bit 
- * samples to 32 bit samples.
- *
- * We also do some scaling in the ioctls that have to do with reporting
- * position and amount of buffer available.
- */
-#define I2S_SCALE_BUFFERS
-
-/*
- *  Getting this from the rme96xx driver.  Has same numerical value
- *  as AC3.  Hmmmm.
- */
-#ifndef AFMT_S32_BLOCKED
-#define AFMT_S32_BLOCKED 0x0000400
-#endif
-
-#define EP93XX_DEFAULT_NUM_CHANNELS      2
-#define EP93XX_DEFAULT_FORMAT            AFMT_S16_LE
-#define EP93XX_DEFAULT_BIT_WIDTH         16
-
-/*
- * Buffer Management
- */
-
-typedef struct {
-
-	int 				size;			/* buffer size 						*/
-	int 				sent;			/* indicates that dma has the buf	*/
-	char 				*start;			/* points to actual buffer 			*/
-	dma_addr_t 			dma_addr;		/* physical buffer address 			*/
-	struct semaphore 	sem;			/* down before touching the buffer 	*/
-	int 				master;			/* owner for buffer allocation,    	*/
-										/* contains size when true 			*/
-	struct audio_stream_s 	*stream;	/* owning stream 					*/
-
-} audio_buf_t;
-
-#define MAX_DEVICE_NAME 20
-
-typedef struct audio_stream_s {
-
-	/* dma stuff */
-	int				dmahandles[3];		/* handles for dma driver instances */
-	char			devicename[MAX_DEVICE_NAME]; /* string - name of device */
-	int				NumDmaChannels;		/* 1, 2, or 3 DMA channels 			*/
-	
-	audio_buf_t 	*buffers;			/* array of audio buffer structures */
-	audio_buf_t 	*buf;				/* current buffer used by read/write */
-	u_int 			buf_idx;			/* index for the pointer above... 	*/
-	u_int 			fragsize;			/* fragment i.e. buffer size 		*/
-	u_int 			nbfrags;			/* nbr of fragments i.e. buffers 	*/
-	u_int			reportedfrags;		/* # of frags reported to app		*/
-	int 			bytecount;			/* nbr of processed bytes 			*/
-	int 			getptrCount;		/* value of bytecount last time 	*/
-										/* anyone asked via GETxPTR 		*/
-	int 			fragcount;			/* nbr of fragment transitions 		*/
-	ep93xx_dma_int_t dma_ch;			/* DMA channel ID 					*/
-	wait_queue_head_t 	wq;				/* for poll 						*/
-	int 			mapped:1;			/* mmap()'ed buffers 				*/
-	int 			active:1;			/* actually in progress 			*/
-	int 			stopped:1;			/* might be active but stopped 		*/
-
-	/*
-	 * Data about the file format that we are configured to play.
-	 */
-	long 				audio_num_channels;			/* Range: 1 to 6 */
-	long 				audio_format;
-	long 				audio_stream_bitwidth;		/* Range: 8, 16, 24, 32 */
-
-} audio_stream_t;
-
-
-/*
- * State structure for one instance
- */
-typedef struct {
-	audio_stream_t 		*output_stream;
-	audio_stream_t 		*input_stream;
-	
-	ep93xx_dma_dev_t 	output_dma;
-	ep93xx_dma_dev_t 	input_dma;
-	
-	char 				*output_id;
-	char 				*input_id;
-	
-	int 				rd_ref:1;			/* open reference for recording */
-	int 				wr_ref:1;			/* open reference for playback */
-	
-	/*
-	 * Pointers to init, shutdown, and ioctl functions.
-	 */
-	void 				(*hw_enable)(int input_or_output_stream);
-	void 				(*hw_disable)(int input_or_output_stream);
-	int 				(*client_ioctl)(struct inode *, struct file *, uint, ulong);
-	void				(*set_hw_serial_format)( long );
-
-	struct 				semaphore sem;		/* to protect against races in attach() */
-
-	/*
-	 * Data about how the audio controller and codec are set up.
-	 */
-	int					DAC_bit_width;		/* 16, 20, 24 bits */
-	int					bCompactMode;		/* set if 32bits = a stereo sample */
-
-} audio_state_t;
-
-/*
- * Functions exported by this module
- */
-extern int ep93xx_audio_attach( struct inode *inode, 
-								struct file *file,
-								audio_state_t *state);
+/*
+ * ep93xx-audio.h
+ *
+ * Common audio handling for the Cirrus Logic EP93xx
+ *
+ * Copyright (c) 2003 Cirrus Logic Corp.
+ * Copyright (c) 2000 Nicolas Pitre <nico@cam.org>
+ *
+ * Taken from sa1100-audio.h
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License.
+ */
+
+/*
+ * If this is #defined we will up the number of buffers we allocate so 
+ * that if an application requests 2 16K buffers for playing 16 bit audio,
+ * we will allocate 4 16K buffers so we have room to expand the 16 bit 
+ * samples to 32 bit samples.
+ *
+ * We also do some scaling in the ioctls that have to do with reporting
+ * position and amount of buffer available.
+ */
+#define I2S_SCALE_BUFFERS
+
+/*
+ *  Getting this from the rme96xx driver.  Has same numerical value
+ *  as AC3.  Hmmmm.
+ */
+#ifndef AFMT_S32_BLOCKED
+#define AFMT_S32_BLOCKED 0x0000400
+#endif
+
+#define EP93XX_DEFAULT_NUM_CHANNELS      2
+#define EP93XX_DEFAULT_FORMAT            AFMT_S16_LE
+#define EP93XX_DEFAULT_BIT_WIDTH         16
+
+/*
+ * Buffer Management
+ */
+
+typedef struct {
+
+	int 				size;			/* buffer size 						*/
+	int 				sent;			/* indicates that dma has the buf	*/
+	char 				*start;			/* points to actual buffer 			*/
+	dma_addr_t 			dma_addr;		/* physical buffer address 			*/
+	int				owner;
+	struct semaphore 	sem;				/* down before touching the buffer 	*/
+	int 				master;			/* owner for buffer allocation,    	*/
+								/* contains size when true 			*/
+	int					num;		/* which out of nbfrags buffers is this?  */
+	struct audio_stream_s 	*stream;			/* owning stream 					*/
+
+} audio_buf_t;
+
+#define MAX_DEVICE_NAME 20
+
+typedef struct audio_stream_s {
+
+	/* dma stuff */
+	int				dmahandles[3];		/* handles for dma driver instances */
+	char			devicename[MAX_DEVICE_NAME]; /* string - name of device */
+	int				NumDmaChannels;		/* 1, 2, or 3 DMA channels 			*/
+	
+	audio_buf_t 	*buffers;			/* array of audio buffer structures */
+	audio_buf_t 	*dma_buffer;				/* current buffer used by read/write */
+	u_int 			dma_buffer_index;		/* index for the pointer above... 	*/
+	u_int 			fragsize;			/* fragment i.e. buffer size 		*/
+	u_int 			nbfrags;			/* nbr of fragments i.e. buffers 	*/
+	u_int			requested_fragsize;
+	u_int			requested_nbfrags;
+	int 			bytecount;			/* nbr of processed bytes 			*/
+	int 			getptrCount;		/* value of bytecount last time 	*/
+										/* anyone asked via GETxPTR 		*/
+	int 			fragcount;			/* nbr of fragment transitions 		*/
+	ep93xx_dma_int_t dma_ch;			/* DMA channel ID 					*/
+	wait_queue_head_t 	wq;				/* for poll 						*/
+	int 			mapped:1;			/* mmap()'ed buffers 				*/
+	int 			active:1;			/* actually in progress 			*/
+	int 			stopped:1;			/* might be active but stopped 		*/
+	u_int			TX_dma_ch_bitfield;	/* bit0 = txdma1, bit1= txdma2, etc */
+	u_int			RX_dma_ch_bitfield;	/* bit0 = rxdma1, bit1= rxdma2, etc */
+	int			bFirstCaptureBuffer;	/* flag meaning there is junk in rx fifo */
+
+	/*
+	 * Data about the file format that we are configured to play.
+	 */
+	long 				audio_num_channels;			/* Range: 1 to 6 */
+	long 				audio_format;
+	long 				audio_stream_bitwidth;		/* Range: 8, 16, 24, 32 */
+
+	long			sample_rate;		/* Fs in Hz. */
+
+	/*
+	 * Data about how the audio controller and codec are set up.
+	 */
+	int			    hw_bit_width;		/* width of dac or adc */
+	int			    bCompactMode;		/* set if 32bits == a stereo sample */
+
+	/*
+	 * dma2usr_ratio = dma sample size (8 or 4 bytes) / usr sample size (8,4,2,1)
+	 */
+	int				dma2usr_ratio;
+
+	/*
+	 * This provides a way of determining audio playback position that will not
+	 * overflow.  This is (size of buffers written) - (buffers we've gotten back)
+	 */
+	int				buffered_bytes_to_play;
+
+} audio_stream_t;
+
+
+/*
+ * No matter how many streams are going, we are using one hardware device.
+ * This struct describes that hardware.
+ */
+typedef struct {
+
+	ep93xx_dma_dev_t	txdmachannels[3];	/* all dma channels available for */
+	ep93xx_dma_dev_t	rxdmachannels[3];	/* this audio ctrlr */
+	
+	int					MaxTxDmaChannels;	/* number of tx and rx channels */
+	int					MaxRxDmaChannels;	/* number of tx and rx channels */
+	
+	/*
+	 * Pointers to init, shutdown, and ioctl functions.
+	 */
+	void 				(*hw_enable)( audio_stream_t * stream);
+	void 				(*hw_disable)(audio_stream_t * stream);
+	void				(*hw_clear_fifo)(audio_stream_t * stream);
+	int 				(*client_ioctl)(struct inode *, struct file *, uint, ulong);
+	void				(*set_hw_serial_format)( audio_stream_t *, long );
+
+	unsigned int		modcnt; 			/* count the # of volume writes */
+
+} audio_hw_t;
+
+/*
+ * State structure for one instance
+ */
+typedef struct {
+	audio_stream_t 		*output_stream;
+	audio_stream_t 		*input_stream;
+	
+	ep93xx_dma_dev_t 	output_dma;
+	ep93xx_dma_dev_t 	input_dma;
+	
+	char 				*output_id;
+	char 				*input_id;
+	
+	int 				rd_ref:1;			/* open reference for recording */
+	int 				wr_ref:1;			/* open reference for playback */
+	
+	/*
+	 * Pointers to init, shutdown, and ioctl functions.
+	 */
+	void 				(*hw_enable)(int input_or_output_stream);
+	void 				(*hw_disable)(int input_or_output_stream);
+	int 				(*client_ioctl)(struct inode *, struct file *, uint, ulong);
+	void				(*set_hw_serial_format)( long );
+
+	struct 				semaphore sem;		/* to protect against races in attach() */
+
+	/*
+	 * Data about how the audio controller and codec are set up.
+	 */
+	int					DAC_bit_width;		/* 16, 20, 24 bits */
+	int					bCompactMode;		/* set if 32bits = a stereo sample */
+
+} audio_state_t;
+
+/*
+ * Functions exported by this module
+ */
+extern int ep93xx_audio_attach( struct inode *inode, 
+								struct file *file,
+								audio_state_t *state);
